"use strict";
{
    const C3 = self.C3;

    C3.Plugins.madex.Instance = class madexInstance extends C3.SDKInstanceBase {
        constructor(inst, properties) {
            super(inst);

            this.publisher_id = "";

            // Dummy methods
            const _dummyInitialize = (PUBLISHER_ID) => {
                console.log("Call Initialize. Launch app in any platform to see result");
            }

            const _dummySetUserConsent = (hasConsent) => {
                console.log("Call SetUserConsent. Launch app in any platform to see result");
            }

            const _dummySetCustomParams = (key, value) => {
                console.log("Call SetUserConsent. Launch app in any platform to see result");
            }

            const _dummyEnableDebug = (enabled) => {
                console.log("Call EnableDebug. Launch app in any platform to see result");
            }

            const _dummyHasUserConsent = () => {
                console.log("Call HasUserConsent. Launch app in any platform to see result");
                return false;
            };

            const _dummyLoadInterstitialAd = (PLACEMENT_NAME) => {
                console.log("Call LoadInterstitialAd. Launch app in any platform to see result");
            }
            const _dummyShowInterstitialAd = (PLACEMENT_NAME) => {
                console.log("Call ShowInterstitialAd. Launch app in any platform to see result");
            }
            const _dummyIsInterstitialAdReady = (PLACEMENT_NAME) => {
                console.log("Call IsInterstitialAdReady. Launch app in any platform to see result");
                return false;
            }
            const _dummyDestroyInterstitialAd = (PLACEMENT_NAME) => {
                console.log("Call DestroyInterstitialAd. Launch app in any platform to see result");
            }
            const _dummyLoadRewardedAd = (PLACEMENT_NAME) => {
                console.log("Call LoadRewardedAd. Launch app in any platform to see result");
            }
            const _dummyShowRewardedAd = (PLACEMENT_NAME) => {
                console.log("Call ShowRewardedAd. Launch app in any platform to see result");
            }
            const _dummyDestroyRewardedAd = (PLACEMENT_NAME) => {
                console.log("Call DestroyRewardedAd. Launch app in any platform to see result");
            }
            const _dummyIsRewardedAdReady = (PLACEMENT_NAME) => {
                console.log("Call IsRewardedAdReady. Launch app in any platform to see result");
                return false;
            }

            if (typeof cordova == 'undefined') {
                this._initialize = _dummyInitialize;
                this._setUserConsent = _dummySetUserConsent;
                this._hasUserConsent = _dummyHasUserConsent;
                this._loadInterstitialAd = _dummyLoadInterstitialAd;
                this._showInterstitialAd = _dummyShowInterstitialAd;
                this._isInterstitialAdReady = _dummyIsInterstitialAdReady;
                this._loadRewardedAd = _dummyLoadRewardedAd;
                this._showRewardedAd = _dummyShowRewardedAd;
                this._destroyInterstitialAd = _dummyDestroyInterstitialAd;
                this._destroyRewardedAd = _dummyDestroyRewardedAd;
                this._isRewardedAdReady = _dummyIsRewardedAdReady;
                this._enableDebug = _dummyEnableDebug;
                this._setCustomParams = _dummySetCustomParams;
                return;
            }

            this.Conditions = C3.Plugins.madex.Cnds;
            this.Madex = cordova.require('cordova.plugin.madex.MadexPlugin');

            if (properties) {
                this.publisher_id = properties[0];
            }


            if (typeof this.Madex == 'undefined') {
                return;
            }

            const self = this;

            const AdType = {
                INTERSTITIAL: 1, // Interstitial Ad
                REWARDED: 3, // Rewarded Ad
            };


            // Methods

            // Settings
            const _initialize = (PUBLISHER_ID) => {

                var isInitialized = self.Madex.isInitialized();

                if (!isInitialized) {
                    self.publisher_id = PUBLISHER_ID;
                    self.Madex.initialize(self.publisher_id);
                }
            }

            // Privacy Methods

            const _setUserConsent = (hasConsent) => {
                self.Madex.setUserConsent(hasConsent);
            }

            const _setCustomParams = (key, value) => {
                self.Madex.setCustomParams(key, value);
            }

            const _enableDebug = (enabled) => {
                self.Madex.enableDebug(enabled);
            }

            const _hasUserConsent = () => {
                return self.Madex.hasUserConsent();
            };

            // Ads Methods
            const _loadInterstitialAd = (PLACEMENT_NAME) => {
                self.Madex.loadAd(AdType.INTERSTITIAL, PLACEMENT_NAME);
            }
            const _showInterstitialAd = (PLACEMENT_NAME) => {
                self.Madex.showAd(AdType.INTERSTITIAL, PLACEMENT_NAME);
            }
            const _isInterstitialAdReady = (PLACEMENT_NAME) => {
                return self.Madex.isAdLoaded(AdType.INTERSTITIAL, PLACEMENT_NAME);
            }
            const _destroyInterstitialAd = (PLACEMENT_NAME) => {
                self.Madex.destroyAd(AdType.INTERSTITIAL, PLACEMENT_NAME);
            }
            const _loadRewardedAd = (PLACEMENT_NAME) => {
                self.Madex.loadAd(AdType.REWARDED, PLACEMENT_NAME);
            }
            const _showRewardedAd = (PLACEMENT_NAME) => {
                self.Madex.showAd(AdType.REWARDED, PLACEMENT_NAME);
            }
            const _destroyRewardedAd = (PLACEMENT_NAME) => {
                self.Madex.destroyAd(AdType.REWARDED, PLACEMENT_NAME);
            }
            const _isRewardedAdReady = (PLACEMENT_NAME) => {
                return self.Madex.isAdLoaded(AdType.REWARDED, PLACEMENT_NAME);
            }


            // Register Methods
            this._initialize = _initialize;
            this._setUserConsent = _setUserConsent;
            this._hasUserConsent = _hasUserConsent;
            this._loadInterstitialAd = _loadInterstitialAd;
            this._showInterstitialAd = _showInterstitialAd;
            this._isInterstitialAdReady = _isInterstitialAdReady;
            this._loadRewardedAd = _loadRewardedAd;
            this._showRewardedAd = _showRewardedAd;
            this._destroyInterstitialAd = _destroyInterstitialAd;
            this._destroyRewardedAd = _destroyRewardedAd;
            this._isRewardedAdReady = _isRewardedAdReady;
            this._enableDebug = _enableDebug;
            this._setCustomParams = _setCustomParams;


            // Register Trigger Events

            // Interstitial Ad
            globalThis.addEventListener('onInterstitialLoaded', (adInfo) => {
                self.Trigger(self.Conditions.OnInterstitialLoaded);
            });
            globalThis.addEventListener('onInterstitialLoadFailed', (adInfo) => {
                self.Trigger(self.Conditions.OnInterstitialLoadFailed);
            });
            globalThis.addEventListener('onInterstitialShown', (adInfo) => {
                self.Trigger(self.Conditions.OnInterstitialShown);
            });
            globalThis.addEventListener('onInterstitialShowFailed', (adInfo) => {
                self.Trigger(self.Conditions.OnInterstitialShowFailed);
            });
            globalThis.addEventListener('onInterstitialClosed', (adInfo) => {
                self.Trigger(self.Conditions.OnInterstitialClosed);
            });

            // Rewarded Ad
            globalThis.addEventListener('onRewardedLoaded', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedLoaded);
            });
            globalThis.addEventListener('onRewardedLoadFailed', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedLoadFailed);
            });
            globalThis.addEventListener('onRewardedShown', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedShown);
            });
            globalThis.addEventListener('onRewardedShowFailed', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedShowFailed);
            });
            globalThis.addEventListener('onRewardedClosed', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedClosed);
            });
            globalThis.addEventListener('onRewardedFinished', (adInfo) => {
                self.Trigger(self.Conditions.OnRewardedFinished);
            });
        }

        Release() {
            super.Release();
        }

        SaveToJson() {
            return {};
        }

        LoadFromJson(o) { }


        GetDebuggerProperties() {
            return [
                {
                    title: "Madex",
                    properties: []
                }
            ];
        }
    };
}